# coding: utf-8

"""


    Generated by: https://openapi-generator.tech
"""

from dataclasses import dataclass
import re  # noqa: F401
import sys  # noqa: F401
import typing
import urllib3
import functools  # noqa: F401

from petstore_api import api_client, exceptions
import decimal  # noqa: F401
from datetime import date, datetime  # noqa: F401
from frozendict import frozendict  # noqa: F401

from petstore_api import schemas  # noqa: F401

from petstore_api.model.string_with_validation import StringWithValidation

from . import path

# query params


class PipeSchema(
    schemas.ListSchema
):
    _items = schemas.StrSchema


class IoutilSchema(
    schemas.ListSchema
):
    _items = schemas.StrSchema


class HttpSchema(
    schemas.ListSchema
):
    _items = schemas.StrSchema


class UrlSchema(
    schemas.ListSchema
):
    _items = schemas.StrSchema


class ContextSchema(
    schemas.ListSchema
):
    _items = schemas.StrSchema
RefParamSchema = StringWithValidation
RequestRequiredQueryParams = typing.TypedDict(
    'RequestRequiredQueryParams',
    {
        'pipe': PipeSchema,
        'ioutil': IoutilSchema,
        'http': HttpSchema,
        'url': UrlSchema,
        'context': ContextSchema,
        'refParam': RefParamSchema,
    }
)
RequestOptionalQueryParams = typing.TypedDict(
    'RequestOptionalQueryParams',
    {
    },
    total=False
)


class RequestQueryParams(RequestRequiredQueryParams, RequestOptionalQueryParams):
    pass


request_query_pipe = api_client.QueryParameter(
    name="pipe",
    style=api_client.ParameterStyle.FORM,
    schema=PipeSchema,
    required=True,
    explode=True,
)
request_query_ioutil = api_client.QueryParameter(
    name="ioutil",
    style=api_client.ParameterStyle.FORM,
    schema=IoutilSchema,
    required=True,
)
request_query_http = api_client.QueryParameter(
    name="http",
    style=api_client.ParameterStyle.SPACE_DELIMITED,
    schema=HttpSchema,
    required=True,
)
request_query_url = api_client.QueryParameter(
    name="url",
    style=api_client.ParameterStyle.FORM,
    schema=UrlSchema,
    required=True,
)
request_query_context = api_client.QueryParameter(
    name="context",
    style=api_client.ParameterStyle.FORM,
    schema=ContextSchema,
    required=True,
    explode=True,
)
request_query_ref_param = api_client.QueryParameter(
    name="refParam",
    style=api_client.ParameterStyle.FORM,
    schema=RefParamSchema,
    required=True,
    explode=True,
)


@dataclass
class ApiResponseFor200(api_client.ApiResponse):
    response: urllib3.HTTPResponse
    body: schemas.Unset = schemas.unset
    headers: schemas.Unset = schemas.unset


_response_for_200 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor200,
)
_status_code_to_response = {
    '200': _response_for_200,
}


class BaseApi(api_client.Api):

    def _query_parameter_collection_format(
        self: api_client.Api,
        query_params: RequestQueryParams = frozendict(),
        stream: bool = False,
        timeout: typing.Optional[typing.Union[int, typing.Tuple]] = None,
        skip_deserialization: bool = False,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization
    ]:
        """
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        self._verify_typed_dict_inputs(RequestQueryParams, query_params)
        used_path = path.value

        prefix_separator_iterator = None
        for parameter in (
            request_query_pipe,
            request_query_ioutil,
            request_query_http,
            request_query_url,
            request_query_context,
            request_query_ref_param,
        ):
            parameter_data = query_params.get(parameter.name, schemas.unset)
            if parameter_data is schemas.unset:
                continue
            if prefix_separator_iterator is None:
                prefix_separator_iterator = parameter.get_prefix_separator_iterator()
            serialized_data = parameter.serialize(parameter_data, prefix_separator_iterator)
            for serialized_value in serialized_data.values():
                used_path += serialized_value
        # TODO add cookie handling

        response = self.api_client.call_api(
            resource_path=used_path,
            method='put'.upper(),
            stream=stream,
            timeout=timeout,
        )

        if skip_deserialization:
            api_response = api_client.ApiResponseWithoutDeserialization(response=response)
        else:
            response_for_status = _status_code_to_response.get(str(response.status))
            if response_for_status:
                api_response = response_for_status.deserialize(response, self.api_client.configuration)
            else:
                api_response = api_client.ApiResponseWithoutDeserialization(response=response)

        if not 200 <= response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)

        return api_response


class QueryParameterCollectionFormat(BaseApi):
    # this class is used by api classes that refer to endpoints with operationId fn names

    def query_parameter_collection_format(
        self: BaseApi,
        query_params: RequestQueryParams = frozendict(),
        stream: bool = False,
        timeout: typing.Optional[typing.Union[int, typing.Tuple]] = None,
        skip_deserialization: bool = False,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization
    ]:
        return self._query_parameter_collection_format(
            query_params=query_params,
            stream=stream,
            timeout=timeout,
            skip_deserialization=skip_deserialization
        )


class ApiForput(BaseApi):
    # this class is used by api classes that refer to endpoints by path and http method names

    def put(
        self: BaseApi,
        query_params: RequestQueryParams = frozendict(),
        stream: bool = False,
        timeout: typing.Optional[typing.Union[int, typing.Tuple]] = None,
        skip_deserialization: bool = False,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization
    ]:
        return self._query_parameter_collection_format(
            query_params=query_params,
            stream=stream,
            timeout=timeout,
            skip_deserialization=skip_deserialization
        )


